/**
* The MIT License
*
* Copyright (c) 2013 saka-en, http://www.saka-en.com/
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
*/
package datepicker
{
	import flash.display.DisplayObject;

	import mx.collections.ArrayCollection;
	import mx.containers.HBox;
	import mx.containers.VBox;

	/**
	 * 半年カレンダー
	 */
	public class SixMonths extends VBox
	{
		/**
		 * １ヶ月目のカレンダー
		 */
		private var _firstCalendar:DatePicker;
		/**
		 * １ヶ月目の平日リスト
		 */
		private var _firstWeekdayList:ArrayCollection;
		/**
		 * １ヶ月目の休日リスト
		 */
		private var _firstHolidayList:ArrayCollection;
		/**
		 * １ヶ月目の土曜日休暇
		 */
		private var _firstSaturdayIsHoliday:Boolean;
		/**
		 * １ヶ月目の日曜日休暇
		 */
		private var _firstSundayIsHoliday:Boolean;

		/**
		 * ２ヶ月目のカレンダー
		 */
		private var _secondCalendar:DatePicker;
		/**
		 * ２ヶ月目の平日リスト
		 */
		private var _secondWeekdayList:ArrayCollection;
		/**
		 * ２ヶ月目の休日リスト
		 */
		private var _secondHolidayList:ArrayCollection;
		/**
		 * ２ヶ月目の土曜日休暇
		 */
		private var _secondSaturdayIsHoliday:Boolean;
		/**
		 * ２ヶ月目の日曜日休暇
		 */
		private var _secondSundayIsHoliday:Boolean;

		/**
		 * ３ヶ月目のカレンダー
		 */
		private var _thirdCalendar:DatePicker;
		/**
		 * ３ヶ月目の平日リスト
		 */
		private var _thirdWeekdayList:ArrayCollection;
		/**
		 * ３ヶ月目の休日リスト
		 */
		private var _thirdHolidayList:ArrayCollection;
		/**
		 * ３ヶ月目の土曜日休暇
		 */
		private var _thirdSaturdayIsHoliday:Boolean;
		/**
		 * ３ヶ月目の日曜日休暇
		 */
		private var _thirdSundayIsHoliday:Boolean;

		/**
		 * ４ヶ月目のカレンダー
		 */
		private var _fourthCalendar:DatePicker;
		/**
		 * ４ヶ月目の平日リスト
		 */
		private var _fourthWeekdayList:ArrayCollection;
		/**
		 * ４ヶ月目の休日リスト
		 */
		private var _fourthHolidayList:ArrayCollection;
		/**
		 * ４ヶ月目の土曜日休暇
		 */
		private var _fourthSaturdayIsHoliday:Boolean;
		/**
		 * ４ヶ月目の日曜日休暇
		 */
		private var _fourthSundayIsHoliday:Boolean;

		/**
		 * ５ヶ月目のカレンダー
		 */
		private var _fifthCalendar:DatePicker;
		/**
		 * ５ヶ月目の平日リスト
		 */
		private var _fifthWeekdayList:ArrayCollection;
		/**
		 * ５ヶ月目の休日リスト
		 */
		private var _fifthHolidayList:ArrayCollection;
		/**
		 * ５ヶ月目の土曜日休暇
		 */
		private var _fifthSaturdayIsHoliday:Boolean;
		/**
		 * ５ヶ月目の日曜日休暇
		 */
		private var _fifthSundayIsHoliday:Boolean;

		/**
		 * ６ヶ月目のカレンダー
		 */
		private var _sixthCalendar:DatePicker;
		/**
		 * ６ヶ月目の平日リスト
		 */
		private var _sixthWeekdayList:ArrayCollection;
		/**
		 * ６ヶ月目の休日リスト
		 */
		private var _sixthHolidayList:ArrayCollection;
		/**
		 * ６ヶ月目の土曜日休暇
		 */
		private var _sixthSaturdayIsHoliday:Boolean;
		/**
		 * ６ヶ月目の日曜日休暇
		 */
		private var _sixthSundayIsHoliday:Boolean;

		/**
		 * コンストラクタ
		 */
		public function SixMonths()
		{
			super();
			super.styleName = "contentsCalendarMainBox";

			// １ヶ月目のデフォルト設定
			_firstWeekdayList = new ArrayCollection;
			_firstHolidayList = new ArrayCollection;
			_firstSaturdayIsHoliday = true;
			_firstSundayIsHoliday = true;
			// ２ヶ月目のデフォルト設定
			_secondWeekdayList = new ArrayCollection;
			_secondHolidayList = new ArrayCollection;
			_secondSaturdayIsHoliday = true;
			_secondSundayIsHoliday = true;
			// ３ヶ月目のデフォルト設定
			_thirdWeekdayList = new ArrayCollection;
			_thirdHolidayList = new ArrayCollection;
			_thirdSaturdayIsHoliday = true;
			_thirdSundayIsHoliday = true;
			// ４ヶ月目のデフォルト設定
			_fourthWeekdayList = new ArrayCollection;
			_fourthHolidayList = new ArrayCollection;
			_fourthSaturdayIsHoliday = true;
			_fourthSundayIsHoliday = true;
			// ５ヶ月目のデフォルト設定
			_fifthWeekdayList = new ArrayCollection;
			_fifthHolidayList = new ArrayCollection;
			_fifthSaturdayIsHoliday = true;
			_fifthSundayIsHoliday = true;
			// ６ヶ月目のデフォルト設定
			_sixthWeekdayList = new ArrayCollection;
			_sixthHolidayList = new ArrayCollection;
			_sixthSaturdayIsHoliday = true;
			_sixthSundayIsHoliday = true;
		}

		/**
		 * カレンダーの作成
		 *
		 * @param startDate 開始日
		 */
		public function creation(startDate:Date):void {
			remove();
			// 1行目のボックス作成し、4か月分のカレンダーを設定
			var firstBox:HBox = new HBox;
			firstBox.name = "_calendarFirstBox";
			firstBox.setStyle("horizontalGap", 2);
			// 1ヶ月目
			_firstCalendar = new DatePicker(startDate);
			var today:Date = new Date;
			_firstCalendar.weekdayList = _firstWeekdayList;
			_firstCalendar.holidayList = _firstHolidayList;
			_firstCalendar.saturdayIsHoliday = _firstSaturdayIsHoliday;
			_firstCalendar.sundayIsHoliday = _firstSundayIsHoliday;
			firstBox.addChild(_firstCalendar.creation());
			// 2ヶ月目
			_secondCalendar = new DatePicker(Util.addMonth(startDate, 1));
			_secondCalendar.weekdayList = _secondWeekdayList;
			_secondCalendar.holidayList = _secondHolidayList;
			_secondCalendar.saturdayIsHoliday = _secondSaturdayIsHoliday;
			_secondCalendar.sundayIsHoliday = _secondSundayIsHoliday;
			firstBox.addChild(_secondCalendar.creation());
			// 3ヶ月目
			_thirdCalendar = new DatePicker(Util.addMonth(startDate, 2));
			_thirdCalendar.weekdayList = _thirdWeekdayList;
			_thirdCalendar.holidayList = _thirdHolidayList;
			_thirdCalendar.saturdayIsHoliday = _thirdSaturdayIsHoliday;
			_thirdCalendar.sundayIsHoliday = _thirdSundayIsHoliday;
			firstBox.addChild(_thirdCalendar.creation());
			// 1行目を作成
			this.addChild(firstBox);

			// 2行目のボックス作成し、4か月分のカレンダーを設定
			var secondBox:HBox = new HBox;
			secondBox.name = "_calendarSecondBox";
			secondBox.setStyle("horizontalGap", 2);
			// 4ヶ月目
			_fourthCalendar = new DatePicker(Util.addMonth(startDate, 3));
			_fourthCalendar.weekdayList = _fourthWeekdayList;
			_fourthCalendar.holidayList = _fourthHolidayList;
			_fourthCalendar.saturdayIsHoliday = _fourthSaturdayIsHoliday;
			_fourthCalendar.sundayIsHoliday = _fourthSundayIsHoliday;
			secondBox.addChild(_fourthCalendar.creation());
			// 5ヶ月目
			_fifthCalendar = new DatePicker(Util.addMonth(startDate, 4));
			_fifthCalendar.weekdayList = _fifthWeekdayList;
			_fifthCalendar.holidayList = _fifthHolidayList;
			_fifthCalendar.saturdayIsHoliday = _fifthSaturdayIsHoliday;
			_fifthCalendar.sundayIsHoliday = _fifthSundayIsHoliday;
			secondBox.addChild(_fifthCalendar.creation());
			// 6ヶ月目
			_sixthCalendar = new DatePicker(Util.addMonth(startDate, 5));
			_sixthCalendar.weekdayList = _sixthWeekdayList;
			_sixthCalendar.holidayList = _sixthHolidayList;
			_sixthCalendar.saturdayIsHoliday = _sixthSaturdayIsHoliday;
			_sixthCalendar.sundayIsHoliday = _sixthSundayIsHoliday;
			secondBox.addChild(_sixthCalendar.creation());
			// 2行目を作成
			this.addChild(secondBox);
		}

		/**
		 * オブジェクトの削除
		 */
		public function remove():void {
			var obj:Object = getChildByName("_calendarFirstBox");
			if ( obj != null )
				this.removeChild(obj as DisplayObject);
			obj = getChildByName("_calendarSecondBox");
			if ( obj != null )
				this.removeChild(obj as DisplayObject);
		}

		/**
		 * 利用可能日リスト取得
		 */
		public function getEnabledList():ArrayCollection {
			var enabledList:ArrayCollection = new ArrayCollection;
			var i:int = 0;
			var date:Date;
			// １か月目
			for ( i = 0; i < _firstCalendar.enabledList.length; i++ ) {
				date = _firstCalendar.enabledList.getItemAt(i) as Date;
				enabledList.addItem(date);
			}
			// ２か月目
			for ( i = 0; i < _secondCalendar.enabledList.length; i++ ) {
				date = _secondCalendar.enabledList.getItemAt(i) as Date;
				enabledList.addItem(date);
			}
			// ３か月目
			for ( i = 0; i < _thirdCalendar.enabledList.length; i++ ) {
				date = _thirdCalendar.enabledList.getItemAt(i) as Date;
				enabledList.addItem(date);
			}
			// ４か月目
			for ( i = 0; i < _fourthCalendar.enabledList.length; i++ ) {
				date = _fourthCalendar.enabledList.getItemAt(i) as Date;
				enabledList.addItem(date);
			}
			// ５か月目
			for ( i = 0; i < _fifthCalendar.enabledList.length; i++ ) {
				date = _fifthCalendar.enabledList.getItemAt(i) as Date;
				enabledList.addItem(date);
			}
			// ６か月目
			for ( i = 0; i < _sixthCalendar.enabledList.length; i++ ) {
				date = _sixthCalendar.enabledList.getItemAt(i) as Date;
				enabledList.addItem(date);
			}
			return enabledList;
		}

		/**
		 * 利用不可能日リスト取得
		 */
		public function getDisabledList():ArrayCollection {
			var disabledList:ArrayCollection = new ArrayCollection;
			var i:int = 0;
			var date:Date;
			// １か月目
			for ( i = 0; i < _firstCalendar.disabledList.length; i++ ) {
				date = _firstCalendar.disabledList.getItemAt(i) as Date;
				disabledList.addItem(date);
			}
			// ２か月目
			for ( i = 0; i < _secondCalendar.disabledList.length; i++ ) {
				date = _secondCalendar.disabledList.getItemAt(i) as Date;
				disabledList.addItem(date);
			}
			// ３か月目
			for ( i = 0; i < _thirdCalendar.disabledList.length; i++ ) {
				date = _thirdCalendar.disabledList.getItemAt(i) as Date;
				disabledList.addItem(date);
			}
			// ４か月目
			for ( i = 0; i < _fourthCalendar.disabledList.length; i++ ) {
				date = _fourthCalendar.disabledList.getItemAt(i) as Date;
				disabledList.addItem(date);
			}
			// ５か月目
			for ( i = 0; i < _fifthCalendar.disabledList.length; i++ ) {
				date = _fifthCalendar.disabledList.getItemAt(i) as Date;
				disabledList.addItem(date);
			}
			// ６か月目
			for ( i = 0; i < _sixthCalendar.disabledList.length; i++ ) {
				date = _sixthCalendar.disabledList.getItemAt(i) as Date;
				disabledList.addItem(date);
			}
			return disabledList;
		}

		/**
		 * １ヶ月目の平日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param firstWeekdayList ArrayCollection
		 */
		public function set firstWeekdayList(firstWeekdayList:ArrayCollection):void {
			if ( firstWeekdayList != null )
				_firstWeekdayList = firstWeekdayList;
		}
		/**
		 * １ヶ月目の休日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param firstHolidayList ArrayCollection
		 */
		public function set firstHolidayList(firstHolidayList:ArrayCollection):void {
			if ( firstHolidayList != null )
				_firstHolidayList = firstHolidayList;
		}
		/**
		 * １ヶ月目の土曜日休み設定
		 *
		 * @param firstSaturdayIsHoliday true:休みである, false:休みでない
		 */
		public function set firstSaturdayIsHoliday(firstSaturdayIsHoliday:Boolean):void {
			_firstSaturdayIsHoliday = firstSaturdayIsHoliday;
		}
		/**
		 * １ヶ月目の日曜日休み設定
		 *
		 * @param firstSundayIsHoliday true:休みである, false:休みでない
		 */
		public function set firstSundayIsHoliday(firstSundayIsHoliday:Boolean):void {
			_firstSundayIsHoliday = firstSundayIsHoliday;
		}

		/**
		 * ２ヶ月目の平日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param secondWeekdayList ArrayCollection
		 */
		public function set secondWeekdayList(secondWeekdayList:ArrayCollection):void {
			if ( secondWeekdayList != null )
				_secondWeekdayList = secondWeekdayList;
		}
		/**
		 * ２ヶ月目の休日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param secondHolidayList ArrayCollection
		 */
		public function set secondHolidayList(secondHolidayList:ArrayCollection):void {
			if ( secondHolidayList != null )
				_secondHolidayList = secondHolidayList;
		}
		/**
		 * ２ヶ月目の土曜日休み設定
		 *
		 * @param secondSaturdayIsHoliday true:休みである, false:休みでない
		 */
		public function set secondSaturdayIsHoliday(secondSaturdayIsHoliday:Boolean):void {
			_secondSaturdayIsHoliday = secondSaturdayIsHoliday;
		}
		/**
		 * ２ヶ月目の日曜日休み設定
		 *
		 * @param secondSundayIsHoliday true:休みである, false:休みでない
		 */
		public function set secondSundayIsHoliday(secondSundayIsHoliday:Boolean):void {
			_secondSundayIsHoliday = secondSundayIsHoliday;
		}
		/**
		 * ３ヶ月目の平日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param thirdWeekdayList ArrayCollection
		 */
		public function set thirdWeekdayList(thirdWeekdayList:ArrayCollection):void {
			if ( thirdWeekdayList != null )
				_thirdWeekdayList = thirdWeekdayList;
		}
		/**
		 * １ヶ月目の休日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param thirdHolidayList ArrayCollection
		 */
		public function set thirdHolidayList(thirdHolidayList:ArrayCollection):void {
			if ( thirdHolidayList != null )
				_thirdHolidayList = thirdHolidayList;
		}
		/**
		 * ３ヶ月目の土曜日休み設定
		 *
		 * @param thirdSaturdayIsHoliday true:休みである, false:休みでない
		 */
		public function set thirdSaturdayIsHoliday(thirdSaturdayIsHoliday:Boolean):void {
			_thirdSaturdayIsHoliday = thirdSaturdayIsHoliday;
		}
		/**
		 * ３ヶ月目の日曜日休み設定
		 *
		 * @param thirdSundayIsHoliday true:休みである, false:休みでない
		 */
		public function set thirdSundayIsHoliday(thirdSundayIsHoliday:Boolean):void {
			_thirdSundayIsHoliday = thirdSundayIsHoliday;
		}
		/**
		 * ４ヶ月目の平日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param fourthWeekdayList ArrayCollection
		 */
		public function set fourthWeekdayList(fourthWeekdayList:ArrayCollection):void {
			if ( fourthWeekdayList != null )
				_fourthWeekdayList = fourthWeekdayList;
		}
		/**
		 * ４ヶ月目の休日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param fourthHolidayList ArrayCollection
		 */
		public function set fourthHolidayList(fourthHolidayList:ArrayCollection):void {
			if ( fourthHolidayList != null )
				_fourthHolidayList = fourthHolidayList;
		}
		/**
		 * ４ヶ月目の土曜日休み設定
		 *
		 * @param fourthSaturdayIsHoliday true:休みである, false:休みでない
		 */
		public function set fourthSaturdayIsHoliday(fourthSaturdayIsHoliday:Boolean):void {
			_fourthSaturdayIsHoliday = fourthSaturdayIsHoliday;
		}
		/**
		 * ４ヶ月目の日曜日休み設定
		 *
		 * @param fourthSundayIsHoliday true:休みである, false:休みでない
		 */
		public function set fourthSundayIsHoliday(fourthSundayIsHoliday:Boolean):void {
			_fourthSundayIsHoliday = fourthSundayIsHoliday;
		}
		/**
		 * ５ヶ月目の平日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param fifthWeekdayList ArrayCollection
		 */
		public function set fifthWeekdayList(fifthWeekdayList:ArrayCollection):void {
			if ( fifthWeekdayList != null )
				_fifthWeekdayList = fifthWeekdayList;
		}
		/**
		 * ５ヶ月目の休日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param fifthHolidayList ArrayCollection
		 */
		public function set fifthHolidayList(fifthHolidayList:ArrayCollection):void {
			if ( fifthHolidayList != null )
				_fifthHolidayList = fifthHolidayList;
		}
		/**
		 * ５ヶ月目の土曜日休み設定
		 *
		 * @param fifthSaturdayIsHoliday true:休みである, false:休みでない
		 */
		public function set fifthSaturdayIsHoliday(fifthSaturdayIsHoliday:Boolean):void {
			_fifthSaturdayIsHoliday = fifthSaturdayIsHoliday;
		}
		/**
		 * ５ヶ月目の日曜日休み設定
		 *
		 * @param fifthSundayIsHoliday true:休みである, false:休みでない
		 */
		public function set fifthSundayIsHoliday(fifthSundayIsHoliday:Boolean):void {
			_fifthSundayIsHoliday = fifthSundayIsHoliday;
		}
		/**
		 * ６ヶ月目の平日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param sixthWeekdayList ArrayCollection
		 */
		public function set sixthWeekdayList(sixthWeekdayList:ArrayCollection):void {
			if ( sixthWeekdayList != null )
				_sixthWeekdayList = sixthWeekdayList;
		}
		/**
		 * ６ヶ月目の休日リスト設定
		 * (配列の中身は Date 型を設定する)
		 *
		 * @param sixthHolidayList ArrayCollection
		 */
		public function set sixthHolidayList(sixthHolidayList:ArrayCollection):void {
			if ( _sixthHolidayList != null )
				_sixthHolidayList = sixthHolidayList;
		}
		/**
		 * ６ヶ月目の土曜日休み設定
		 *
		 * @param sixthSaturdayIsHoliday true:休みである, false:休みでない
		 */
		public function set sixthSaturdayIsHoliday(sixthSaturdayIsHoliday:Boolean):void {
			_sixthSaturdayIsHoliday = sixthSaturdayIsHoliday;
		}
		/**
		 * ６ヶ月目の日曜日休み設定
		 *
		 * @param sixthSundayIsHoliday true:休みである, false:休みでない
		 */
		public function set sixthSundayIsHoliday(sixthSundayIsHoliday:Boolean):void {
			_sixthSundayIsHoliday = sixthSundayIsHoliday;
		}
	}
}